-------------------------------------------------------------------------------
-- English localization (Default)
-- By Dr. Doom
-------------------------------------------------------------------------------

-- Bindings
getfenv()["BINDING_HEADER_XTRADEBAR_TITLE"]  = "XBar";
getfenv()["BINDING_NAME_XTRADEBAR_SHOWHIDE"] = "Show/hide XTradeBar";

-- As of XTradeBar 1.05 (XBar 1.10) or higher, the specialties must come right before their respective tradeskills
-- Note that the master weaponsmithing skills take precedence over the general skill "weaponsmith" and must appear before

-- The &idhack& metacommand was removed due to Blizzard removing the old crafting interface.  Testing to see if it is still affected.

-- Tradeskills
getfenv()["XTradeBarSpells"] = {
    "#Alchemy",
	"Transmutation Master",
	"Potion Master",
	"Elixir Master",
	"Alchemy",
    "#Blacksmithing",
	"Master Swordsmith",
	"Master Axesmith",
	"Master Hammersmith",
	"Armorsmith",
	"Weaponsmith",
	"Blacksmithing",
    "#Mining",
	"Smelting",
    "#Enchanting",
	"Enchanting",
	"Disenchant",
    "#Engineering",
	"Gnomish Engineer",
	"Goblin Engineer",
	"Engineering",
	"#Inscription",
	"Inscription",
	"Decipher",
	"Milling",
	"Minor Inscription Research",
	"Northrend Inscription Research",
    "#Leatherworking",
	"Dragonscale Leatherworking",
	"Elemental Leatherworking",
	"Tribal Leatherworking",
	"Leatherworking",
    "#Tailoring",
	"Mooncloth Tailoring",
	"Spellfire Tailoring",
	"Shadoweave Tailoring",
	"Tailoring",
    "#Jewelcrafting",
	"Jewelcrafting",
	"Prospecting",
    "#Rogue",
	"Pick Lock",
	"Pick Pocket",
    "#Secondary",
	"First Aid",
	"Cooking",
	"Basic Campfire",
	"Fishing",
    "#Tracking",
	"Find Minerals",
	"Find Herbs",
	"Find Treasure",
	"Find Fish",
};


local i,v;

-- Auto-translate the spells
if (GetLocale() ~= "enUS") and (GetLocale() ~= "enGB") then
	if getfenv()["XBARLOCALIZER"] then
		for i,v in pairs(getfenv()["XTradeBarSpells"]) do
			-- We are presuming that everything we need to use the idhack meta command for is a tradeskill, which is not in Babble-Spell, but in Babble-Tradeskill instead
			if strsub(getfenv()["XTradeBarSpells"][i],1,8)=="" then
				getfenv()["XTradeBarSpells"][i]=""..XBar_BabbleTrade(strsub(getfenv()["XTradeBarSpells"][i],2));
			else
				getfenv()["XTradeBarSpells"][i]=XBar_BabbleSpell(getfenv()["XTradeBarSpells"][i]);
			end
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("XBarLocalizer not loaded.");
	end
end
